﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media.Imaging;
using System.IO;
using System.Windows.Forms;
/// <summary>
//Based on blog post from Chris van Beek
/// </summary>
namespace BenCapCam
{
    public class AutomaticMultiPartReader 
    {
        private MultiPartStream _mps;
        private bool _reading = false;
        private byte[] _currentPart;
        public event EventHandler<PartReadyEventArgs> PartReady;

        public AutomaticMultiPartReader(MultiPartStream stream)
        {
            _mps = stream;
        }
        protected virtual void OnPartReady()
        {
            if (PartReady != null)
            {
                PartReadyEventArgs args = new PartReadyEventArgs();
                args.Part = _currentPart;
                PartReady(this, args);
            }
        }
        public async void StartProcessing()
        {
            _reading = true;
            while (_reading)
            {
                
                _currentPart = await _mps.NextPartAsync().ConfigureAwait(false);
                OnPartReady();
            }
        }

        public void StopProcessing()
        {
            _mps.Close();
            _reading = false;
        }
        public void StopProcessing2()
        {
            _reading = false;
        }
        public void Start()
        {
            StartProcessing();
        }
        
    }
}
